! ems.S for the Linux DOS emulator
!   provide a V86-mode ISR and device driver for EMS emulation
!
! License on original linux.asm:
!
! #Mach Operating System
! #Copyright (c) 1993,1992,1991,1990 Carnegie Mellon University
! #Copyright (c) 1991 IBM Corporation 
! #All Rights Reserved.
! #
! #Permission to use, copy, modify and distribute this software and its
! #documentation is hereby granted, provided that both the copyright
! #notice and this permission notice appear in all copies of the
! #software, derivative works or modified versions, and any portions
! #thereof, and that both notices appear in supporting documentation,
! #and that the nema IBM not be used in advertising or publicity 
! #pertaining to distribution of the software without specific, written
! #prior permission.
! # 
! #CARNEGIE MELLON AND IBM ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS IS"
! #CONDITION.  CARNEGIE MELLON AND IBM DISCLAIM ANY LIABILITY OF ANY KIND FOR
! #ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
! # 
! #Carnegie Mellon requests users of this software to return to
! #
! # Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
! # School of Computer Science
! # Carnegie Mellon University
! # Pittsburgh PA 15213-3890
! #
! #any improvements or extensions that they make and grant Carnegie Mellon
! #the rights to redistribute these changes.
! # 
! #MACHFS.ASM  MS-DOS device driver to interface mach file system
! #with the dos server's monitor.
! #
! #Version 1.1
! #
! #Gerald Malan (grm) 4/5/1991
!
! modified for the linux dos emulator by Andrew Tridgell 13/4/93
! translated into as86 form by Robert Sanders ('murrcan style date!) 4/13/93
! (I probably broke something, but it seems to work)
!
! copied from emufs.S to make ems.S  -  7/19/93
!
! $Date: 1995/01/14 15:32:57 $
! $Source: /home/src/dosemu0.60/commands/RCS/ems.S,v $
! $Revision: 1.1 $
! $State: Exp $
!

use16

.text
.bss
.data
.align 0

	.org	0

MaxCmd	=	15
cr	=	0xd
lf	=	0xa
eom	=	'$'		! DOS end-of-string character (barf)
LinuxEMS =	0xe6		! 0xe6 is Int for Linux EMS server
EMSint	=	0x67
vecoff   = 	(EMSint * 4)   ! mem loc for the interrupt vector
vecseg	=	(vecoff + 2)

.globl _main
_main:

Header:
	.long	-1		! link to next device driver
	.word	0xC000		! attribute word for driver 
				! (char, supports IOCTL strings (it doesn't!)
	.word	Strat		! ptr to strategy routine
	.word	Intr		! ptr to interrupt service routine
	.ascii	"EMMXXXX0"	! logical-device name

! the Strat and Intr routines are entered with a "far call".  I don't
! know how to tell as86 that as I would in Turbo Assembler, so I just
! explicitly "retf" at the end of their execution.  Be careful!

RHPtr:	.long	0		! ptr to request header

InitDone: .word 0		! 1 when initialisation is complete

Version:  .word 1		! 1 = version 0.61+

Dispatch: .word DispatchNew

DispatchOld:
	.word	Init		! initialize driver
	.word	DummyOld	! Media Check ,block only
	.word	DummyOld	! Build BPB, block only
	.word	DummyOld	! Ioctl
	.word	DummyOld	! read
	.word	DummyOld  	! non-destructive read
	.word	DummyOld	! input status
	.word	DummyOld	! flush input
	.word	DummyOld	! write
	.word	DummyOld	! write with verify
	.word	DummyOld	! output status
	.word	DummyOld	! flush output
	.word	DummyOld	! IOCTL output (??)
! if DOS 3.0 or newer...
	.word	DummyOld	! open device
	.word	DummyOld	! close device
	.word	DummyOld	! removeable media check

DispatchNew:
	.word	Init		! initialize driver
	.word	Dummy		! Media Check ,block only
	.word	Dummy		! Build BPB, block only
	.word	Dummy		! Ioctl
	.word	Dummy		! read
	.word	Dummy  		! non-destructive read
	.word	Dummy		! input status
	.word	Dummy		! flush input
	.word	Dummy		! write
	.word	Dummy		! write with verify
	.word	Dummy		! output status
	.word	Dummy		! flush output
	.word	Dummy		! IOCTL output (??)
! if DOS 3.0 or newer...
	.word	Dummy		! open device
	.word	Dummy		! close device
	.word	Dummy		! removeable media check

Strat:
	seg cs
	mov	[RHPtr], bx
	seg cs
	mov	[RHPtr+2],es
	retf

Intr:
	push	ax
	push	bx
	push	cx
	push	dx
	push	ds
	push	es
	push	di
	push	si
	push	bp
	
	push	cs
	pop	ds

	les	di,[RHPtr]	! let es:di = request header

	seg es
	movb	bl,[di+2]
	xorb	bh,bh
	cmp	bx, #MaxCmd
	jle	Intr1
	call	Error
	jmp	Intr2

Intr1:	shl	bx,#1
	seg cs
	add	bx,[Dispatch]
	call	[bx]

	les	di,[RHPtr]

Intr2:	or	ax,#0x100		! Merge done bit with status
	seg es
	mov	[di+3],ax

	pop	bp
	pop	si
	pop	di
	pop	es
	pop	ds
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	retf

DummyOld:
	call	EMSini
	les	di, [RHPtr]
	seg es
	mov	bl, [di+2]  ! get request number
	xor	bh,bh

	mov     al, #0x21
	int	LinuxEMS

	xor	ax,ax
	ret


Dummy:
	call	EMSini
	les	di, [RHPtr]
	seg es
	mov	bl, [di+2]  ! get request number
	xor	bh,bh

	call	#0xFC00:#0x0FF2

	xor	ax,ax
	ret

Int67Old:
	push	ax
	mov	ax, #0x22
	int	LinuxEMS
	iret

Int67:
	call	#0xFC00:#0x0FF1
	iret

Error:
	mov	ax,#0x8003
	ret

EMSini:
	push	es
	push	ds
	push	di

	push	cs			! DS = data segment
	pop	ds

	mov	ax,[InitDone]
	or	ax,ax
	jne	AlreadyDone

	mov	ah, #0xc0
	int	0x15
	mov	cx, #7
	mov	di, bx			! ES:DI = BIOS name
	add	di, #10
	mov	si, #VerCheck		! DS:SI = Version check

	.byte   0xf3, 0xa6		! repz	cmpsb
	jcxz	Version_OK

	mov	ax, #DispatchOld
	mov	[Dispatch], ax

	xor	ax, ax
	mov	[Version], ax

Version_OK:
	mov	dx, #Int67		! DS:DX = Int 67 routine
	mov	ax, [Version]
	or	ax, ax
	jnz	Int67_okay
	mov	dx, #Int67Old
Int67_okay:
	mov	ax, #0x2567
	int	0x21

	mov	ax, #1
	seg cs
	mov	[InitDone],ax

AlreadyDone:
	pop	di
	pop	ds
	pop	es
	ret


Init:
	xor	bx,bx

	cmp	ax, #0
	jne	EMSin

EMSout:
	push	cs
	pop	ds
	mov	ah,  #9
	mov	dx,  #OutMess
	int	0x21

	seg es 
	movb	[di+13],#0		! No units!!
	seg es
	mov	[di+20],cs
	seg es
	mov	[di+14],#0		!Break addr = cs:0000
	seg es
	mov	[di+16],cs

	ret

EMSin:
	call	EMSini

	seg es
	movb	al, [di+22]
	add	al, #0x41

	push	cs
	pop	ds

	mov	dx, #Message
	mov	ax, [Version]
	or	ax, ax
	jne	message_ok
	mov	dx, #MessageOld
message_ok:
	mov	ah, #9
	int	0x21

	seg es
	mov	[di+14], #Init
	seg es
	mov	[di+16], cs

	xor ax,ax

	ret

Message:
	.ascii	"[dosemu EMS 4.0 driver installed]"
	.byte	cr,lf,cr,lf,eom

MessageOld:
	.ascii	"[dosemu EMS 4.0 driver installed]"
	.byte	cr,lf
	.ascii	"You may wish to update your version of DOSEMU"
	.byte	cr,lf,cr,lf,eom

OutMess:
	.byte	cr,lf,lf
	.ascii	"EMS Server not responding."
	.byte	cr,lf
	.ascii	"Installation aborted."
	.byte	cr,lf,lf,eom

NoName:	.ascii	"NO NAME"
	.byte	0

VerCheck:
	.ascii	"DOSEMU "

	end


