! exitemu.S, to generate exitemu.com, for dosemu 0.49, 4/9/93
! Original code by:  Robert Sanders
! Modified by:       Scott Buchholz

.text
.data
.bss

.align 0

cr	= 0xd
lf	= 0xa
eom	= '$'

.globl _main              ! for ld86
_main:
	.org	0x100

	mov	ah, #0xC0		! Get ROM BIOS information
	int	#0x15
	mov	cx, #7
	mov	di, bx			! ES:DI = BIOS name
	add	di, #10
	push	cs
	pop	ds
	mov	si, #VerCheck		! DS:SI = Version check
	add	si, #0x100
	.byte   0xf3, 0xa6		! repz	cmpsb
	jcxz	Version_OK

	mov	ax, #0x35E6		! Get the Int 0xE6 vector
	int	0x21

	mov	ax, es			! Sanity check -- if 0xE6 -> 0000:0000
	or	ax, bx			!   don't call it!
	jz	Not_Dosemu
	mov	ax, #0xffff
	int	0xe6			! Exit dosemu

Not_Dosemu:
        mov	dx, #Warning		! Not DOSEMU -- print warning
	add	dx, #0x100		! [magic offset for .COM files]
	push	cs
	pop	ds
        mov	ah, #0x09
        int	0x21
	int	0x20			! exit

Version_OK:				! Version 0.61+
	call	#0xFC00:#0x0FFE		! Dos helper
	int	0x20			! exit

VerCheck:
	.ascii	"DOSEMU "

Warning:
        .ascii	"-------Exitemu can not be run under DOS"
        .byte cr,lf,eom


