#ifndef __DOSEMU_CONFIG_H__
#define __DOSEMU_CONFIG_H__

/****************************************************************************
 * Do not edit this portion of the file                                     *
 ****************************************************************************/

#include "autoconf.h"
#include "config.make.h"

#define YYPURE              /* for lex & yacc files */
#define DOSEMU 1            /* for mfs mangler      */
#define MANGLE 1            /*   ditto              */
#define MANGLED_STACK 50    /*   ditto              */

/****************************************************************************
 * You may edit anything below this point                                   *
 ****************************************************************************/

#define LIBDOSEMU           "/usr/lib/dosemu"
#define CONFIG_FILE         "/etc/dosemu.conf"
#define DOSEMU_USERS_FILE   "/etc/dosemu.users"
#define PATH_LOCKD          "/usr/spool/uucp"
#define NAME_LOCKF          "LCK.."
/*  #define PATH_LOCKD          "/var/lock"  */

/****************************************************************************
 * Various options
 ****************************************************************************/

/*
 * This option currently doesn't work.  Ideally, one day it will be redundant
 * as everything should be run in user mode.  Note to hacker's:  please try
 * to enable priv's around priv-needing (e.g. ioperm, /proc/mem op's, etc.)
 * operations and disable them just afterwards
 */

/* #define RUN_AS_USER */

/*
 * if you set this to 1, then you will be able to use your MDA + monitor
 * as second display. This currently is possibe together with
 * Video_term, Video_console and Video_graphics.
 * You also must set the keyword "dualmon" in the video section
 * of your /etc/dosemu.conf.
 * With dualmonitor support you can run CAD-programs, debuggers, or
 * simple change your PC-console with "mode mono"
 * NOTE: 
 *   Currently this can't be used together with VIDEO_CHECK_DIRTY,
 *   because the kernel (vm86.c) would remap all video pages
 *   from 0xa0000 to 0xbffff.
 */
#define CONFIG_DUALMON 0

/*
 * if you set this to 1, the video memory dirty bit will be checked 
 * before updating the screen.
 * (this affects emu.c and video/int10.c)
 */
#define CONFIG_VIDEO_CHECK_DIRTY 0

#define CONFIG_USE_SCROLL_QUEUE 0

/****************************************************************************
 * Assorted, probably outdated options
 ****************************************************************************/

/* #define SILLY_GET_GEOMETRY */
/* #define CONFIG_SIMPLE_FORK */
/* #define CONFIG_SYNC_ALOT */
/* #define USE_FSYNC */

/****************************************************************************
 * Debugging options
 ****************************************************************************/

/*
 * Set this to 0 to completely disable DEBUG printf's
 */
#define CONFIG_DEBUG_PRINTF 1

/* #define CONFIG_DEBUG */
/* #define CONFIG_DEBUG_VERBOSE */
/* #define SHOWREGS */

/*
 * CONFIG_SHOW_TIME specifies whether or not to dump times with the *_printf
 * statements.
 * 0 means disabled.
 * 1 means enabled.
 */
#define CONFIG_SHOW_TIME 0

/*
 * CONFIG_TIMER_STATS specifies whether or not to collect timer statistics
 * This option will slow down execution somewhat, but generate useful
 * information for checking the timer event accuracy.
 * 0 means disabled.
 * 1 means enabled.
 */ 
#define TIMER_STATS 0

/*
 * CONFIG_HLT_TRACE specifies whether or not to debug HLT breaks
 * 0 means disabled.
 * 1 means enabled.
 */ 
#define CONFIG_HLT_TRACE 1

/*
 * CONFIG_PORT_TRACE specifies whether or not to debug dump port writes.
 * 0 means disabled.
 * 1 means record all port accesses to 0x00 to 0xFF
 * 2 means record ANY port accesses!  (big fat debugfile!)
 */ 
#define CONFIG_PORT_TRACE 2

/****************************************************************************
 * MFS options
 ****************************************************************************/

/* #define DOQUALIFY */
/* #define KANJI */
/* #define NOTEST */
/* #define NO_VOLUME_LABELS */
/* #define PROFILE */
/* #define UNDOCUMENTED_FUNCTION_2 */
/* #define USE_DF_AND_AFS_STUFF */

/****************************************************************************
 * IPX options
 ****************************************************************************/

/* #define CONFIG_IPXPICPKT */

/****************************************************************************
 * X-windows keyboard options
 ****************************************************************************/

/* #define CONFIG_NEW_KEYCODES */

/****************************************************************************
 * EMUMODULE options
 ****************************************************************************/

/* #define CONFIG_VM86PLUS */
/* #define _LOADABLE_VM86_ */
/* #define _VM86_STATISTICS_ */
/* #define USE_VM86PLUS */
/* #define USE_VM86_STACKVERIFY */
/* #define HACKER_TOOL */
/* #define SHAME_ON_YOU */
/* #define CONFIG_IGNORE_NMI */
/* #define CONFIG_MATH_EMULATION */

#endif /* __DOSEMU_CONFIG_H__ */
