# You may edit this file to suit your desires
#
# 0.61 alpha comment:
#   (XXX) flags an untested option (e.g. it probably won't work)  Scott

##############################################################################
# Architecture specifies the platform for which you are compiling:
#    linux     -- Linux i386-based machines
#    netbsd    -- NetBSD i386-based machines
#
# Emulator specifies the instruction emulator to use:
#    i386      -- Use the vm86() function in Linux & hacked NetBSD
#    bochs     -- (eventually) use the Bochs emulator
#    marty     -- (perhaps Marty wants to do this one? :)
##############################################################################

ARCH       = linux
EMULATOR   = i386

##############################################################################
# Compilation/Linker options
##############################################################################

# Uncomment this line to make ELF binaries (XXX).
# Since there are many versions of the ELF compilers floating around, I'm
# afraid that you're going to have to figure this one out based on your
# configuration.  If you don't know what ELF is, don't worry, you probably
# don't have it.
#	CONFIG_ELF=y
#	CC=gcc-elf
#	CFLAGS += <put your elf-flags>

# Put any extra flags to send to the C compiler on this line (make Marty happy)
	CFLAGS += -m486 -pipe

# I have a gcc script which invokes all warnings.  This is an example of how
# to do similarly.  On the other hand, you can just uncomment the next block.
#	CC=gcc-wall

# Uncomment these lines to provide gcc error checking
	CFLAGS += -Wall -fstrict-prototypes -Wstrict-prototypes -Wmissing-prototypes -Wnested-externs -Wshadow -Wcast-qual -Wcast-align -Wpointer-arith -Winline -Wenum-clash -Wid-clash-31 -Wwrite-strings -Wcomment

##############################################################################
# Utilities
##############################################################################

# Uncomment this line to compile the TEX documentation (XXX)
#	CONFIG_HAVE_TEX=y

# Uncomment this line if you have the GNU autoconf utility installed
#	CONFIG_HAVE_AUTOCONF=y

##############################################################################
# Support options
##############################################################################

# Uncomment this line to provide Linux EMUMODULE support (this allows DPMI
# support without repatching the kernel)
#	CONFIG_EMUMODULE=y

# Uncomment this to get Silly Interrupt support.  This requires EMUMODULE
# to function properly.  It allows you to reflect hardware IRQ interrupts
# to DOSEMU from your hardware devices.
#	CONFIG_SIG=y

# Make the dos static binaries (dosstatic)
#	CONFIG_DOSSTATIC=y

# Uncomment this line to get IPX support (XXX)
#	CONFIG_IPX=y

# Uncomment this to get V-Net support (outdated?) (XXX)
#	CONFIG_VNET=y

# Compile the files with '-g' debugging information
#	CONFIG_DEBUG=y

# Generate *.d files when 'make depend' is run instead of .depend files
#	CONFIG_D_FILES=y

##############################################################################
#  DOSEMU 'environments'
#
#  Note:
#     (TTT) means that the code has not yet been tested
#     (DDD) means that the code almost works (it may work for some of the
#           possible configurations)
##############################################################################

# Include support for X-windows (if X-windows is detected)
	CONFIG_ENV_X=y

# DDD - Include support for Linux consoles
	CONFIG_ENV_CONSOLE=y

# Include support for VGA consoles (requires CONFIG_ENV_CONSOLE)
	CONFIG_ENV_VGA=y

# TTT - Include support for ARK VGA cards (requires CONFIG_ENV_VGA)
	CONFIG_ENV_VGA_ARK=y

# TTT - Include support for ATI VGA Wonder+ cards (requires CONFIG_ENV_VGA)
	CONFIG_ENV_VGA_ATI=y

# TTT - Include support for Cirrus SVGA cards (requires CONFIG_ENV_VGA)
	CONFIG_ENV_VGA_CIRRUS=y

# TTT - Include support for ET3000-based SVGA cards (requires CONFIG_ENV_VGA)
	CONFIG_ENV_VGA_ET3000=y

# TTT - Include support for ET4000-based SVAG cards (requires CONFIG_ENV_VGA)
	CONFIG_ENV_VGA_ET4000=y

# TTT - Include support for GVGA6400-based SVGA cards (requires CONFIG_ENV_VGA)
	CONFIG_ENV_VGA_GVGA6400=y

# Include support for ATI Mach32 cards (requires CONFIG_ENV_VGA)
#	CONFIG_ENV_VGA_MACH32=y
# note:  Mach32 support is not currently written!!!

# TTT - Include support for OAK SVGA cards (requires CONFIG_ENV_VGA)
	CONFIG_ENV_VGA_OAK=y

# Include support for Paradise/Western Digital SVGA cards
# (requires CONFIG_ENV_VGA)
	CONFIG_ENV_VGA_PARADISE=y

# DDD - Include support for S3-based VGA cards (requires CONFIG_ENV_VGA)
	CONFIG_ENV_VGA_S3=y

# TTT - Include support for Trident 8800+ VGA cards (requires CONFIG_ENV_VGA)
	CONFIG_ENV_VGA_TRIDENT=y
